#pragma semicolon 1
#include <sourcemod>

#define PLUGIN_VERSION "1.0"

public Plugin:myinfo =
{
	name		= "Russian Chat",
	author		= "Root",
	description	= "Adds Cyrillics support in game chat",
	version		= PLUGIN_VERSION,
	url			= "http://steamcommunity.com/id/zadroot/"
};

public OnPluginStart()
{
	AddCommandListener(Command_Say, "say");
	AddCommandListener(Command_Say, "say_team");
}

public Action:Command_Say(client, const String:command[], args)
{
	decl String:text[256];

	if (GetCmdArgString(text, sizeof(text)) > 0)
	{
		if (CyrrilycReplase(text))
		{
			decl String:cmd[32];
			GetCmdArg(0, cmd, sizeof(cmd));

			FakeClientCommandEx(client, "%s %s", cmd, text);

			return Plugin_Stop;
		}
	}
	return Plugin_Continue;
}

bool:CyrrilycReplase(String:text[])
{
	new bool:IsRussian = false;

	new textlen = strlen(text) - 1;

	for (new i = 0; i <= textlen; i++)
	{
		if (GetCharBytes(text[i]) == 2)
		{
			if ((text[i] == 0xc3) && (text[i+1] > 0x7f) && (text[i+1] < 0xc0))
			{
				if (text[i+1] > 0xaf)
				{
					text[i]   += 0xe;
					text[i+1] -= 0x30;
				} else {
					text[i]   += 0xd;
					text[i+1] += 0x10;
				}
				IsRussian = true;
			}
			else if ((text[i] == 0xc2)
				&& (text[i+1] == 0xbf))
			{
				text[i]   = 0xd1;
				text[i+1] = 0x8a;
				IsRussian = true;
			}
			else if ((text[i] == 0xc2)
				&& (text[i+1] == 0xaf))
			{
				text[i]   = 0xd0;
				text[i+1] = 0xaa;
				IsRussian = true;
			}
			else if ((text[i] == 0xc2)
				&& (text[i+1] == 0xba))
			{
				text[i]   = 0xd1;
				text[i+1] = 0x8d;
				IsRussian = true;
			}
			else if ((text[i] == 0xc2)
				&& (text[i+1] == 0xaa))
			{
				text[i]   = 0xd0;
				text[i+1] = 0xad;
				IsRussian = true;
			}
			else if ((text[i] == 0xc2)
				&& (text[i+1] == 0xb3))
			{
				text[i]   = 0xd1;
				text[i+1] = 0x8b;
				IsRussian = true;
			}
			else if ((text[i] == 0xc2)
				&& (text[i+1] == 0xb2))
			{
				text[i]   = 0xd0;
				text[i+1] = 0xab;
				IsRussian = true;
			}
			else if ((text[i] == 0xc2)
				&& (text[i+1] == 0xb8))
			{
				text[i]   = 0xd1;
				text[i+1] = 0x91;
				IsRussian = true;
			}
			else if ((text[i] == 0xc2)
				&& (text[i+1] == 0xa8))
			{
				text[i]   = 0xd0;
				text[i+1] = 0x81;
				IsRussian = true;
			}
			i++;
		}
	}
	return IsRussian;
}